

//============================================================
// IONIC
//============================================================

var app = angular.module('heyBub', ['ionic', 'ngCordova', 'heyBub.controllers', 'heyBub.services'])

app.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

       
    initLocalUsersSettings();
    doSettings();

  });
})



app.config(function($ionicConfigProvider, $stateProvider, $urlRouterProvider) {

  // ANDROID FIXES
  $ionicConfigProvider.views.maxCache(10);
  $ionicConfigProvider.tabs.style("standard");
  $ionicConfigProvider.tabs.position("bottom");
  $ionicConfigProvider.navBar.alignTitle("center")

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider 

  // Each tab has its own nav history stack:

  .state('create', {
    url: '/create',
    //abstract: true,
    views: {
      'app': {
        templateUrl: 'templates/create.html'
        ,controller: 'CreateCtrl'
      }
    }
  })
  .state('publish', {
    url: '/publish',
    //abstract: true,
    views: {
      'app': {
        templateUrl: 'templates/publish.html'
        ,controller: 'PublishCtrl'
      }
    }
  })

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/create');

});







//============================================================
// UTILS
//============================================================


/* Determine touch events support */
var hasTouchSupport = (function(){
  
  if ('ontouchstart' in document.documentElement) {
    return true;
  }
  
}());

function isTouchDevice()
{  
  try {
    document.createEvent("TouchEvent");
    return true;
  } 
  catch (e) {
    return false;
  }  
}

var eventListenerStart,
  eventListenerMove,
  eventListenerEnd;

/* Define event names */
var events;
if(hasTouchSupport){
  events = {
    start: "touchstart",
    move: "touchmove",
    end: "touchend",
    cancel: "touchcancel"
  };
}else{
  events = {
    start: "mousedown",
    move: "mousemove",
    end: "mouseup",
    cancel: "touchcancel" // unnecessary here
  };
}





//============================================================
// LOCAL SETTINGS
//============================================================
var localUsersSettings;   

/*//helper to get Object size
Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

// Get the size of an object
var size = Object.size(myArray);*/

//CHECK ARRAY EXISTANCE, needs user_id
function initLocalUsersSettings()
{
  //console.log("initLocalUsersSettings",window.localStorage.getItem("localUsersSettings"),localUsersSettings[user_id]);
  
  var localSettings;
  
  if ( window.localStorage.getItem("localUsersSettings") == null)
  {
    console.log("NO localUsersSettings");
    localUsersSettings = new Object();      
    initUserSettings()
  }
  else
  {
    //RETREIVE ARRAY.
    localUsersSettings = JSON.parse(window.localStorage.getItem("localUsersSettings"));
  }
}

function initUserSettings()
{
  var localSettings = new Object()
  localSettings["save_originals"] ="on";
  localSettings["save_mobile"]  ="on";
  localSettings["save_online"]  ="on";
  
  localUsersSettings = localSettings;
  
  window.localStorage.setItem( "localUsersSettings", JSON.stringify(localUsersSettings) );
}


function doSettings()
{ 
  var localSettings = localUsersSettings;
  
  for(var index in localSettings)
  {
      var setting_name = index;
    var setting_value = localSettings[index];
    
    // TEMP : On inverse la valeur car le label passe de "Save Online" à "Private Mode".
    if(setting_name == "save_online")
    {
      setting_value = (setting_value == "on") ? "off" : "on";
    }
    
    $('#select-'+setting_name).val(setting_value);//.slider('refresh');
        
    //console.log("doSettings",user_id,setting_name,setting_value,$('#select-'+setting_name).val())
  }
}

function updateSettings(e)
{
  var sel = $(e.target);  
  var setting_name = sel.attr('name');
  var setting_value = sel.val();
  
  // TEMP : On inverse la valeur car le label passe de "Save Online" à "Private Mode".
  if(setting_name == "save_online")
  {
    setting_value = (setting_value == "on") ? "off" : "on";
  }
  
  //console.log("updateSettings",user_id,setting_name,setting_value)
  
  //save settings on LS
  localUsersSettings[setting_name] = setting_value;
  window.localStorage.setItem( "localUsersSettings", JSON.stringify(localUsersSettings));
  
}
