//============================================================
//
// CREATE
//
//============================================================
var $scopeCreate;
var appCtrls = angular.module('heyBub.controllers', [])
var stage;
var currentTarget;
var container_Text;
var pictureSource;   // picture source
var destinationType; // sets the format of returned value 
var container_pix,container_bubbles,container_help;
var container_bubble;
var bubblesR = new Array(); 
var bubbleX;
var bubbleY;
var currentBubble;
var canvas2ImagePlugin;
var canvasCreate;
var canvasW;
var device_version,device_type,window_height;
var isH480 = false, isH568=false, ratioDevice=1,canvasScale;
var fontsR = 
    [
      "Delius-Regular",         
      "Bangers",              
      "PermanentMarker",        
      "Allan-Regular",
      "HelveticaNeue-Light",
      "Knewave-Regular",
      "Allan-Bold",
      "Boogaloo-Regular",
      "CevicheOne-Regular",
      "FrederickatheGreat",
      "Oregano-Regular",
      "Ranchers-Regular",                
      "Unkempt-Regular",
      "Creepster-Regular",       
      "ClickerScript-Regular"
    ];

appCtrls.controller('CreateCtrl', function($scope,$state,$ionicPopup,$cordovaSplashscreen) {

  $scope.isNext = false;
  $scopeCreate = $scope;

  ionic.Platform.ready(function(){
    
    console.log("-- Create -- ") 

    $scope.isNext = false;
    initFonts(); 
    getDeviceInfos();
    initCanvas();
    initEditHolder();
    initInterface();
    setMenuBubbles();
    initMenuBubbles();
    
    setTimeout(function() {$cordovaSplashscreen.hide();}, 200 );
    
  });

  $scope.setNext = function(bool) {
    
    $scope.isNext = bool;
  }  

  $scope.onNextClick = function() {

    $state.go("publish", { "id": 0 });
  }

  $scope.capturePhotoEdit = function() {
    
     capturePhotoEdit()

  }

  $scope.getPhoto = function() {
    
    getPhoto();
  }

  $scope.resetCanvas = function() {
    
     $ionicPopup.confirm({
       title: 'Confirmation',
       template: 'Are you sure you want to reset canvas?'
     })
     .then(function(res) {
       if(res) {
         resetCanvas();
       } 
     });
  }

  $scope.showConfirm = function() {
   var confirmPopup = $ionicPopup.confirm({
     title: 'Confirmation',
     template: 'Are you sure you want to remove this bubble?'
   });
   confirmPopup.then(function(res) {
     if(res) {
       removeBubble(currentBubble);
     } 
   });
 };


})



//============================================================
// FONTS
//============================================================

function initFonts()
{
  $.each(fontsR,function(index,value)
  {
    //console.log(value);
    var spanfont = '<span style="font-family:'+value+'">a</span>';
    $('#loading').prepend(spanfont);
  })
}

//============================================================
// FUNCTIONS
//============================================================


function getDeviceInfos()
{
  
  window_height = window.innerHeight;
  ratioDevice = window.devicePixelRatio/2;  
  canvasW = $('#canvas_holder').width()
  $('#canvas_holder').height(canvasW)
  $('#canvas_holder').height(canvasW)
  canvasScale = $('#canvasCreate').attr("width") / canvasW;
  canvasCssScale = 1 / canvasScale;
  device_type = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
  //device_version = parseFloat(window.device.version);

  console.log("Device type : " + device_type);
  //console.log("Device type : " + device_type + ' - ' + device_version);
  console.log("Device size : " + ratioDevice + ", canvasScale : " + canvasScale  +", canvasCssScale : " + canvasCssScale)

  //ADJUST

  if(window_height <= 480)
  {
    isH480 = true;
  }
  else if(window_height >= 540)
  {
    //iphone5
    isH568 = true;
    $('body').addClass('ip5');
  }

  $('#canvasCreate').css({'-webkit-transform-origin':'0 0' , '-webkit-transform': 'scale('+canvasCssScale+')'});
  
  /*if (device_type == "iPhone" && device_version >= 7) 
  {
    //margin-top
    $('body').addClass('ios7');
  }*/
} 


//============================================================
// CANVAS
//============================================================


function startTicking()
{
  // call update on the stage to make it render the current display list to the canvas:
  createjs.Ticker.setFPS(50); 
  createjs.Ticker.addListener(this);  
}
function stopTicking()
{
  createjs.Ticker.removeListener(this); 
}

function tick()
{
  stage.update(); 
  //console.log('tick');    
}

function resetCanvas()
{
  console.log("resetCanvas");
  stage.removeAllChildren();
  addContainerPix();
  addContainerBubbles();
  addContainerHelp();
  stage.update();
  hideBtnNext();
  hideEditHolder();
}

function initCanvas() {
    
  console.log("initCanvas");
  
  // get a reference to the canvas we'll be working with:
  canvasCreate = document.getElementById("canvasCreate");
  //canvasCreate.compositeOperation = "darker";
  
  var hidefCanvas = $('#canvasCreate')[0];
  var hidefContext = hidefCanvas.getContext('2d');
  
  if (window.devicePixelRatio) {
    var hidefCanvasWidth = $(hidefCanvas).attr('width');
    var hidefCanvasHeight = $(hidefCanvas).attr('height');
    var hidefCanvasCssWidth = hidefCanvasWidth;
    var hidefCanvasCssHeight = hidefCanvasHeight;
    $(hidefCanvas).attr('width', hidefCanvasWidth * window.devicePixelRatio);
    $(hidefCanvas).attr('height', hidefCanvasHeight * window.devicePixelRatio);
    $(hidefCanvas).css('width', hidefCanvasCssWidth);
    $(hidefCanvas).css('height', hidefCanvasCssHeight);
    hidefContext.scale(window.devicePixelRatio, window.devicePixelRatio);
  }
  
  stage = new createjs.Stage(canvasCreate); 
  stage.addEventListener("stagemouseup", handleMouseUp);
  stage.autoClear = true;
  stage.snapToPixelEnabled = true;
  createjs.Touch.enable(stage);
  
  addContainerPix();
  addContainerBubbles();
  addContainerHelp();
  
  stage.update();
} 

function addContainerPix()
{
  container_pix = new createjs.Container(); 
  //container_pix.addEventListener("mousedown", function(event){hideEditHolder()});
  
  var graphics = new createjs.Graphics().beginFill("#efefef").drawRect(0, 0, canvasCreate.width, canvasCreate.height);
  var shape = new createjs.Shape(graphics);
  shape.name="whitepix";
  shape.addEventListener("mousedown", function(event){hideEditHolder()});
  container_pix.addChild(shape);  
  
  //window.localStorage.removeItem("isHelp");
    
  stage.addChild(container_pix);
}

function addContainerBubbles()
{
  container_bubbles = new createjs.Container();
  stage.addChild(container_bubbles);
}

function addContainerHelp()
{
  container_help = new createjs.Container();
  stage.addChild(container_help);
  
  if ( window.localStorage.getItem("isHelp") != "NO")
  { 
    addHelp()
  }
  else
  {
    addHelpSmall()
  }
}



function addHelp()
{
  var img = new Image();
  img.onload = handleImageLoad;
  img.id = "help";
  img.src = "img/help.png"; 

  var graphicsclose = new createjs.Graphics().beginFill("#FFFFFF").drawRect(0, 0, 74, 74);
  var shapeclose = new createjs.Shape(graphicsclose);
  shapeclose.name="shapeclose";
  shapeclose.alpha=0.01;
  shapeclose.x = canvasW*2*ratioDevice*canvasScale - 74*ratioDevice;
  shapeclose.scaleX = shapeclose.scaleY = ratioDevice;
  shapeclose.addEventListener("mousedown", onCloseHelpPress);
  container_help.addChild(shapeclose);
}

function addHelpSmall()
{
  var img = new Image();
  img.onload = handleImageLoad;
  img.id = "help_small";
  img.src = "img/help_small.png";
}

var isHelpTweening = false

function onCloseHelpPress(e)
{
  if(! isHelpTweening && window.localStorage.getItem("isHelp") != "NO" )
  {
    window.localStorage.setItem( "isHelp", "NO"); 
    
    isHelpTweening = true
    startTicking();
    createjs.Tween.get(container_help.getChildByName('help_bmp')).to({
      alpha:0,
    },200,createjs.Ease.quartOut).call(function()
    {
      stopTicking();
      container_help.removeChild(container_help.getChildByName('shapeclose'))
      container_help.removeChild(container_help.getChildByName('help_bmp'))
      isHelpTweening = false
    })
    
    container_help.removeChild(container_help.getChildByName('shapeclose'))
    //container_help.removeChild(container_help.getChildByName('help_bmp'))
    
    addHelpSmall();
    
    stage.update();
  }
}

function onHelpBtnPress(e)
{
  if(! isHelpTweening)
  {
    window.localStorage.setItem( "isHelp", "YES");
    container_help.removeChild(container_help.getChildByName('help_smallbmp'))
    
    addHelp();  
    
    stage.update();
  }
}

function handleImageLoad(e)
{                     
  //log("loaded : " + e.target.id);
  console.log("loaded : " + e.target.id);
  
  var img = e.target;
  var id = e.target.id;         
  var bmp = new createjs.Bitmap(img);
  bmp.id = id;    
      
  if(id=="help")
  {
    bmp.name = 'help_bmp';
    bmp.cache(0,0,img.width,img.height);
    bmp.alpha = 0;
    container_help.addChildAt(bmp,0);
    
    bmp.ratioX = canvasCreate.width/img.width
    bmp.ratioY = canvasCreate.height/img.height
    
    bmp.addEventListener("mousedown", function(event){hideEditHolder()});
    
    if(img.width>img.height)
    {
      bmp.scaleX = bmp.scaleY = bmp.ratioY
    }   
    else
    {
      bmp.scaleX = bmp.scaleY = bmp.ratioX 
    }
    
    isHelpTweening = true
    startTicking();
    createjs.Tween.get(bmp).to({
      alpha:1,
    },200,createjs.Ease.quartOut).call(function()
    {
      stopTicking();
      isHelpTweening = false
    })
    
    //console.log("#######"+bmp.scaleX)
    
  }
  else if(id=="help_small")
  {
    bmp.name = 'help_smallbmp';
    bmp.cache(0,0,78,74);
    bmp.x = canvasW*2*ratioDevice*canvasScale - img.width*canvasScale*ratioDevice

    console.log("canvasW : " + canvasW + ", ratioDevice : " + ratioDevice + ", canvasScale : " + canvasScale  +", canvasCssScale : " + canvasCssScale)

    bmp.scaleX = bmp.scaleY = canvasScale*ratioDevice;
    bmp.addEventListener("mousedown", onHelpBtnPress);
    container_help.addChild(bmp);
  }   
  else if(id=="pix")
  { 
    onCloseHelpPress(null)  
    
    bmp.name = 'pix_bmp';
    bmp.cache(0,0,img.width,img.height);
    container_pix.removeAllChildren();
    container_pix.addChild(bmp);
        
    bmp.ratioX = canvasCreate.width/img.width
    bmp.ratioY = canvasCreate.height/img.height
    
    if(img.width > img.height)
    {
      bmp.scaleX = bmp.scaleY = bmp.ratioY
    }   
    else
    {
      bmp.scaleX = bmp.scaleY = bmp.ratioX 
    }
    
    bmp.width = img.width*bmp.scaleX
    bmp.height = img.height*bmp.scaleY        
    bmp.addEventListener("mousedown", handlePixPress);
    
    console.log("container_pix add bmp: " + bmp.ratioX);
    console.log("Pix size : " + img.width + "/" +  img.height)
    
    showBtnNext();    
  }
  else
  {
    onCloseHelpPress(null)    
    
    console.log("handleImageLoad : "+pE.x,pE.y,ratioDevice,container_bubble.zoom )
    
    bmp.name = 'bubble_bmp';
    container_bubble.addChildAt(bmp,0); 
    container_bubble.getChildByName("bubble_bmp").regX = bmp.image.width * container_bubble.regBX;
    container_bubble.getChildByName("bubble_bmp").regY = bmp.image.height * container_bubble.regBY;
    
    container_bubble.x = (pE.x*2*canvasScale*ratioDevice)+container_bubble.getChildByName("bubble_bmp").regX*canvasScale*ratioDevice*0.5 //canvasCreate.width/2;
    container_bubble.y = (pE.y*2*canvasScale*ratioDevice)-container_bubble.getChildByName("bubble_bmp").regY*canvasScale*ratioDevice*0.5 //canvasCreate.height*0.40;
    
    if(container_bubble.type!="splash")
    {
      onTextChange();   
    }
    
    startTicking();

    createjs.Tween.get(container_bubble).to({
      scaleX:container_bubble.zoom,
      scaleY:container_bubble.zoom
    },300,createjs.Ease.backOut).call(function()
    {
      stopTicking(); 
      showEditHolder();
    })  
    
    showBtnNext();   
  }
  
  stage.update();
}

function handlePixPress(event)
{
  console.log('handlePixPress')
  
  hideEditHolder();
    
  var target = event.target;
  offsetPix = {x:target.x-event.stageX, y:target.y-event.stageY};
  
  event.onMouseMove = handlePixMove;  
  stage.update()  
}

function handlePixMove(event)
{
  console.log('handlePixMove')
  var bmp = container_pix.getChildByName("pix_bmp");  
  
  if(bmp.width>bmp.height)
  {
    bmp.x = Math.max(canvasCreate.width-bmp.width,Math.min(0,event.stageX+offsetPix.x));
  }
  else
  {
    bmp.y = Math.max(canvasCreate.height-bmp.height,Math.min(0,event.stageY+offsetPix.y));
  }
  
  stage.update();
}


function showBtnNext()
{
  $scopeCreate.setNext(true);
  // force the scope to update
  $scopeCreate.$apply(); 
}

function hideBtnNext()
{
  $scopeCreate.setNext(false);
  // force the scope to update
  $scopeCreate.$apply();
}

//============================================================
// BUBBLES
//============================================================
  
function removeBubble(bubble)
{
  startTicking(); 
  createjs.Tween.get(bubble).to({
    alpha:0,
    scaleX:0,
    scaleY:0
  },300,createjs.Ease.backIn).call(function()
  {
    container_bubbles.removeChild(bubble); 
    stopTicking();
    if(container_pix.getChildAt(0).name == "whitepix" && container_bubbles.getNumChildren() == 0) hideBtnNext();  
  })  
    
  hideEditHolder()
}

function addBubble(bubble_id,type,spaceX,spaceY,regBX,regBY,font_color)
{
  spaceX = typeof spaceX !== 'undefined' ? spaceX : 0;
  spaceY = typeof spaceY !== 'undefined' ? spaceY : 0;
  regBX = typeof regBX !== 'undefined' ? regBX : 0.5;
  regBY = typeof regBY !== 'undefined' ? regBY : 0.5;
  font_color = typeof font_color !== 'undefined' ? font_color : '#000';
    
  console.log("addBubble : " + type + "/" + bubble_id + "/" + spaceX + "/" + spaceY + "/" + regBX + "/" + regBY);
  
  // init container bubble
  container_bubble = new createjs.Container();
  container_bubble.scaleX = 0;
  container_bubble.scaleY = 0;  
  container_bubble.zoom = (type=="splash") ? 0.5*canvasScale*ratioDevice : 1*canvasScale*ratioDevice; 
  container_bubble.rotatePos=0;
  container_bubble.radius = 0;
  container_bubble.isOut = false;
  container_bubble.isCompo = false;
  container_bubble.isLock = false;
  container_bubble.fontSize = 30;
  container_bubble.fontId = 0;
  container_bubble.fontColor = font_color;
  container_bubble.text = "";
  container_bubble.spaceX = parseInt(spaceX);
  container_bubble.spaceY = parseInt(spaceY);
  container_bubble.regBX = parseFloat(regBX);
  container_bubble.regBY = parseFloat(regBY);
  container_bubble.id = bubble_id;
  container_bubble.type = type
  container_bubble.addEventListener("mousedown", handlePress);
  container_bubble.addEventListener("click", handleClick);
  currentBubble = container_bubble;
  
  // add text
  if(type!="splash") addBubbleText(container_bubble); 
  
  container_bubbles.addChild(container_bubble);
    
  // load bubble img  
  var img = new Image();
  img.onload = handleImageLoad;
  img.src = "img/bubbles/"+bubble_id+".png";
}

function addBubbleText(container)
{
  var bubble_textarea = new createjs.Text(container.text, container.fontSize+"px "+fontsR[container.fontId], container.fontColor);
  bubble_textarea.name = "bubble_textarea"
  bubble_textarea.outline = false;
  bubble_textarea.lineWidth   = (container.id == "b_square") ? 570 : 300; // Doesn't work on IOS 5
  bubble_textarea.maxWidth  = (container.id == "b_square") ? 570 : 300;
  bubble_textarea.lineHeight  = container.fontSize+4;
  //bubble_textarea.textBaseline = "middle";
  
  bubble_textarea.textAlign = "center";
  $('#bubble_edit_holder textarea').val("");
  container.addChild(bubble_textarea);  
  
  //console.log("addBubbleText : " + container.id + " bubble_textarea.maxWidth : " + bubble_textarea.maxWidth  + " canvasCreate.width : " + canvasCreate.width)
}

function removeBubbleText(container)
{
  container.removeChild(container.getChildByName("bubble_textarea")); 
}

function updateBubbleText(container)
{
  removeBubbleText(container);
  addBubbleText(container); 
  $('#bubble_edit_holder textarea').val(container.text);
  onTextChange(); 
}

function zoomBubble(container)
{
  container.scaleX =  container.scaleY =  container.zoom;
  stage.update();
  /*startTicking();
  createjs.Tween.get(container, {override:true}).to({
    scaleX:container.zoom,
    scaleY:container.zoom
  },100,createjs.Ease.quadInOut).call(function(){stopTicking();}) */
}

function rotateBubble(container)
{
  var bubble_bmp = container.getChildByName("bubble_bmp");
  var scaleX = bubble_bmp.scaleX;
  var scaleY = bubble_bmp.scaleY;
  
  if(currentBubble.rotatePos==0)
  {
    //BL
    bubble_bmp.scaleX = Math.abs(scaleX);
    bubble_bmp.scaleY = Math.abs(scaleY);
  }
  else if(currentBubble.rotatePos==1)
  {
    //BR
    bubble_bmp.scaleX = -Math.abs(scaleX);
    bubble_bmp.scaleY = Math.abs(scaleY);
  }
  else if(currentBubble.rotatePos==2)
  {
    //TR
    bubble_bmp.scaleX = -Math.abs(scaleX);
    bubble_bmp.scaleY = -Math.abs(scaleY);    
  }
  else if(currentBubble.rotatePos==3)
  {
    //TL
    bubble_bmp.scaleX = Math.abs(scaleX);
    bubble_bmp.scaleY = -Math.abs(scaleY);
  }
  
  stage.update();
}


function handleClick(event)
{ 
  var target = event.target;
  /*if(target.type!="splash")   showEditHolder();
  else            hideEditHolder();*/
  
  if( ! target.isOut) showEditHolder();
    
  return false;
}

function handleMouseUp(event)
{
  var target = currentTarget;
  if (target == null) { return; }
  target.isMouseDown = false;
  
  console.log("currentBubble.isOut : "+currentBubble.isOut)
  
  if(currentBubble.isOut)
  {
    removeBubble(currentBubble);
  }
  
  currentTarget = null;
  
  stage.update();
}


function handlePress(event)
{
  var target = event.target;
  currentTarget = target;
  currentBubble = target;
                  
  offset = {x:target.x-event.stageX, y:target.y-event.stageY};
  
  //z-index
  container_bubbles.addChildAt(target, container_bubbles.children.length - 1);
  
  currentTarget.isMouseDown = true;
  
  target.oldX = target.x;
  target.oldY = target.y;

  event.onMouseMove = handleMove; 
  stage.update(); 
}

function handleMove(event)
{

  currentTarget.x = event.stageX+offset.x;
  currentTarget.y = event.stageY+offset.y;
    
  if (
    (currentTarget.y + currentTarget.radius) > canvasCreate.height)   
  {
     //console.log("delete")
     currentTarget.alpha= .5;
     currentBubble.isOut = true;
  } 
  else
  {
    currentTarget.alpha= 1;
    currentBubble.isOut = false;
  }
  
  stage.update();
  
}












//============================================================
// INTERFACE
//============================================================

function hitCanvas(x,y)
{
  var bounds = $('#canvas_holder').offset();
  bounds.right = bounds.left + $('#canvas_holder').outerWidth();
  bounds.bottom = bounds.top + $('#canvas_holder').outerHeight();
  if(x >= bounds.left){
    if(x <= bounds.right){
      if(y >= bounds.top){
        if(y <= bounds.bottom){
          //console.log(x,y,bounds.left,bounds.right,bounds.top,bounds.bottom)
          return true;
        }
      }
    }
  } 
}



function initInterface()
{
  console.log("initInterface");

  $('#content-create').on(events.start,function() 
  {
    hideEditHolder(); 
  });

  $('#canvas_holder').on(events.start,function(event){
      event.stopPropagation();
  });

  $('#bubble_edit_holder').on(events.start,function(event){
      event.stopPropagation();
  });



  
  
  $('#close_bubble_edit_holder').on(events.start,function()
  {
    hideEditHolder();   
  });
   
  
  $('#btn_composite').on(events.start,function()
  {
    if(currentBubble.isCompo)
    {
      currentBubble.getChildByName("bubble_bmp").compositeOperation = "source-over";
      currentBubble.isCompo = false;
      $('#btn_composite').removeClass('actif');
    }
    else
    {
      currentBubble.getChildByName("bubble_bmp").compositeOperation = (currentBubble.id == "b_square" ) ? "darker" : "lighter";
      currentBubble.isCompo = true;
      $('#btn_composite').addClass('actif');
    }
    
    stage.update();
    
  });
  
  $('#btn_fontsize_up').on(events.start,function()
  {

    currentBubble.fontSize+=4;        
    updateBubbleText(currentBubble);    
  });
  
  $('#btn_fontsize_down').on(events.start,function()
  {
    currentBubble.fontSize-=4;      
    updateBubbleText(currentBubble);    
  });
  
  $('#btn_fontfam').on(events.start,function()
  {
    currentBubble.fontId++
    if(currentBubble.fontId>fontsR.length-1) currentBubble.fontId = 0;
    console.log("font : "+fontsR[currentBubble.fontId])
    updateBubbleText(currentBubble);
  }); 
  
  $('#btn_zoom_up').on(events.start,function()
  {

    onZoomBtnActive(1.1); 
    clearInterval(zoom_int);
    zoom_int = setInterval(function(){onZoomBtnActive(1.01)},10);
  });
  
  $('#btn_zoom_up').on(events.end,function()
  {
    clearInterval(zoom_int);
  });
  
  $('#btn_zoom_down').on(events.start,function()
  {
    onZoomBtnActive(0.9);
    clearInterval(zoom_int);  
    zoom_int = setInterval(function(){onZoomBtnActive(0.99)},10);   
  });
  
  $('#btn_zoom_down').on(events.end,function()
  {
    clearInterval(zoom_int);      
  });
  
  $('#btn_rotate').on(events.start,function()
  {
    currentBubble.rotatePos++;
    if(currentBubble.rotatePos>3) currentBubble.rotatePos = 0;
    rotateBubble(currentBubble);    
  });
  
  $('#btn_remove').on(events.start,function()
  {
    if(currentBubble.type !="splash" && currentBubble.text!="")
    {

      $scopeCreate.showConfirm();
    }
    else
    {
      removeBubble(currentBubble) 
    }
  });
    
    
    
}

var zoom_int,
zoom_max = 7, 
zoom_min = 0.2;

function onZoomBtnActive(factor)
{ 
  currentBubble.zoom *= factor;
  currentBubble.zoom = Math.min(zoom_max*ratioDevice,Math.max(zoom_min*ratioDevice,currentBubble.zoom));
  zoomBubble(currentBubble);  
}


function initEditHolder()
{ 
  $('#bubble_edit_holder textarea').keyup(onTextChange);
  //$('#bubble_edit_holder textarea').focus();
  //$('#bubble_edit_holder textarea').blur(function() {hideEditHolder()});
}

function showEditHolder()
{ 
  //SETUP BTNS
  if(currentBubble.type=="splash")
  {
    $('#speech_holder textarea').attr('disabled','disabled').addClass('disabled').val(" ").blur();
    //$('#btns_holder').addClass('nospeesch');
    //$('#speech_holder').slideUp(200);
    //$('#btn_fontsize_up').parent().hide();
    //$('#btn_fontsize_down').parent().hide();
    $('#btn_fontfam').hide();   
    //$('#btn_zoom_up').parent().show();
    //$('#btn_zoom_down').parent().show();
  }
  else
  {   
    $('#speech_holder textarea').removeAttr('disabled').removeClass('disabled').val(currentBubble.text)
    //setTimeout(function(){$('#btns_holder').removeClass('nospeesch'); $('#speech_holder').slideDown(200);},150);
    //$('#btn_fontsize_up').parent().show();
    //$('#btn_fontsize_down').parent().show();
    $('#btn_fontfam').show();     
    //$('#btn_zoom_up').parent().hide();
    //$('#btn_zoom_down').parent().hide();    
  }
  
  if(currentBubble.isCompo)   $('#btn_composite').addClass('actif');
  else            $('#btn_composite').removeClass('actif');
  
  
  $('#menu_bubbles_holder_scroll').css({"opacity":0,"transition" : "opacity .2s ease-out"})
  $('#bubble_edit_holder').stop().slideDown(200); 
  
}

function hideEditHolder()
{
  $('#menu_bubbles_holder_scroll').css({"opacity":1,"transition" : "opacity .2s ease-out"})
  $('#bubble_edit_holder').stop().slideUp(200);  
  $('#bubble_edit_holder textarea').blur(); 
}

function onTextChange()
{
  //console.log("Text : " + $('#bubble_edit_holder textarea').val());
  
  currentBubble.text = $('#bubble_edit_holder textarea').val(); 
  var bubble_textarea = currentBubble.getChildByName("bubble_textarea");  
    
  var arr = currentBubble.text.split("\n");
  var nblines = arr.length;
  var max_width = 0;
  $.each(arr,function(index,value){ 
    bubble_textarea.text = value  
    var w = bubble_textarea.getMeasuredWidth()
    if(w > max_width) max_width = w;    
  })
  
  bubble_textarea.text = currentBubble.text;  
  bubble_textarea.y = -bubble_textarea.getMeasuredHeight()/2;
  
  
    
  var width = Math.min(bubble_textarea.maxWidth+currentBubble.spaceX,max_width+currentBubble.spaceX);
  var height = bubble_textarea.getMeasuredHeight()+currentBubble.spaceY/2 +nblines*currentBubble.spaceY/7;
  
  currentBubble.getChildByName("bubble_bmp").scaleX = width / currentBubble.getChildByName("bubble_bmp").image.width;
  currentBubble.getChildByName("bubble_bmp").scaleY = height / currentBubble.getChildByName("bubble_bmp").image.height;
  
  rotateBubble(currentBubble);

  stage.update();
  
}








//============================================================
// CAMERA
//============================================================

// Called when a photo is successfully retrieved
function onPhotoDataSuccess(imageData) {
  // Uncomment to view the base64 encoded image data
  // console.log(imageData);
  /*var pix = document.getElementById('pix');
  pix.style.display = 'block';
  pix.src = "data:image/jpeg;base64," + imageData;*/
  
  var img = new Image();
  img.onload = handleImageLoad;
  img.id = "pix";
  img.src = "data:image/jpeg;base64," + imageData;
  //$('#saveImg').show().attr('src',"data:image/jpeg;base64," + imageData);
  
  //console.log("onPhotoDataSuccess : " + img.src)
  
  //alert($('#pix').width())
}

// Called when a photo is successfully retrieved
function onPhotoURISuccess(imageURI) {
  // Uncomment to view the image file URI 
  // console.log(imageURI);
  //var pix = document.getElementById('pix');
  //pix.src = imageURI;
     
  var img = new Image();
  img.onload = handleImageLoad;
  img.id = "pix";
  img.src = imageURI;
  
  //console.log("onPhotoURISuccess : " + imageURI)
  
}

// A button will call this function
/*function capturePhoto() {
  // Take picture using device camera and retrieve image as base64-encoded string
  navigator.camera.getPicture(onPhotoDataSuccess, onFail, { quality: 50,
  destinationType: destinationType.DATA_URL });
}*/

// A button will call this function
function capturePhotoEdit() {

  // Take picture using device camera, allow edit, and retrieve image as base64-encoded string  
  navigator.camera.getPicture(onPhotoDataSuccess, onFail, 
  { 
    quality: 100, 
    allowEdit: false,
    destinationType: Camera.DestinationType.DATA_URL,
    encodingType: Camera.EncodingType.JPEG
    ,targetWidth: 612*canvasScale
    ,targetHeight: 612*canvasScale
    //,saveToPhotoAlbum: (localUsersSettings["save_originals"]=="on") ? true : false
  });
}

// A button will call this function
function getPhoto() {

  navigator.camera.getPicture(onPhotoURISuccess, onFail, 
  { 
    quality: 100, 
    destinationType: Camera.DestinationType.FILE_URI,
    encodingType: Camera.EncodingType.JPEG,
    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
    targetWidth: 612*canvasScale,
    targetHeight: 612*canvasScale,
  });

}

// Called if something bad happens.
function onFail(message) {
  //alert('Failed because: ' + message);
}











//============================================================
// SCROLLERS
//============================================================
var pS,pM,pE,$clone,cW,cH,$bubble_btn;

function setMenuBubbles()
{ 
  //SET HEIGHT
  var menu_bubbles_holder_height = (window.innerHeight ? window.innerHeight : $(window).height()) - $("#canvas_holder").outerHeight(true) - $("ion-header-bar").outerHeight(true) - $(".tab-nav").outerHeight(true) - 15;
  // console.log("window.innerHeight : " + (window.innerHeight ? window.innerHeight : $(window).height()))
  // console.log("canvas_holder Height : " + $("#canvas_holder").outerHeight(true))
  // console.log("ion-header-bar Height : " + $("ion-header-bar").outerHeight(true))
  // console.log("ion-tabs Height : " + $(".tab-nav").outerHeight(true))
  // console.log("menu_bubbles_holder_height : " + menu_bubbles_holder_height)
  //console.log("menu_bubbles_holder_width : " + menu_bubbles_holder_width)
  
  $('#menu_bubbles_holder img').css({'height':menu_bubbles_holder_height});
  $('#menu_bubbles_holder_scroll').css({'height':menu_bubbles_holder_height});
  $('#menu_bubbles_holder').css({'height':menu_bubbles_holder_height});

  //SET WIDTH
  //console.log($('#menu_bubbles_holder a').length)
  var menu_bubbles_holder_width = 0;

  $('#menu_bubbles_holder a').each(function()
  {
    menu_bubbles_holder_width += $(this).outerWidth(true);
    //console.log("menu_bubbles_holder_width : " + $(this).outerWidth(true) + ' - '+menu_bubbles_holder_width)
  })  

  $('#menu_bubbles_holder').css({'width':menu_bubbles_holder_width+86});
}

function initMenuBubbles()
{ 
  
  //SET EVENTS
  $("#menu_bubbles_holder a img").on(events.start, function(e) {    
    
    $bubble_btn = $(this).parent();
    $clone = $(this).clone(); 
    $clone.width($(this).width())
    $clone.height($(this).height())
    cW = $clone.width();
    cH = $clone.height();
    
    $clone.addClass('clone').appendTo('#create_holder'); 

    
  });

  $('#create_holder').on(events.move, function(e) {    
      
    e.preventDefault();

    if($bubble_btn)
    {

      if(hasTouchSupport)
      {
        var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
        pM = { 'x': touch.pageX -cW/2, 'y': touch.pageY - $('#create_holder').offset().top -cH/2 };
      }
      else
      {
        pM = { 'x': e.clientX -cW/2, 'y': e.clientY - $('#create_holder').offset().top -cH/2};
      }   

      $clone.css({top: pM.y, left: pM.x}); 

      //console.log("cW : " + cW);
      //console.log("cH : " + cH);
      
      if(hitCanvas(pM.x+cW/2,pM.y+cH))  $clone.css({opacity:1});
      else                              $clone.css({opacity:0.5}); 
    }

  });

  $('#create_holder').on(events.end, function(e) {    
    
    //e.preventDefault();

    if($bubble_btn)
    {

      if(hasTouchSupport)
      {
        var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
        pE = { 'x': touch.pageX-cW/2, 'y': touch.pageY-cH/2 };
      }
      else
      {
        pE = { 'x': e.clientX-cW/2, 'y': e.clientY-cH/2 };
      }   
          
      if(hitCanvas(pE.x+cW/2,pE.y+cH))
      {
        console.log('HIT')
        onBtnBubbleClic($bubble_btn)
      }
          
      $clone.remove(); 
      $bubble_btn = null;
   }
  });
}

function onBtnBubbleClic(bubble_btn)
{ 
  var bubble_id = bubble_btn.attr('id');
  var type = bubble_btn.attr('data-type');
  var spaceX = bubble_btn.attr('data-spaceX');
  var spaceY = bubble_btn.attr('data-spaceY');
  var regBX = bubble_btn.attr('data-regBX');
  var regBY = bubble_btn.attr('data-regBY');
  var font_color = bubble_btn.attr('data-font_color');
  addBubble(bubble_id,type,spaceX,spaceY,regBX,regBY,font_color)
  
  return false;
}


































//============================================================
//
// PUBLISH
//
//============================================================
var isSavedToPhoneLib,isUploadToServer;
var imageData;
var imageURI;
var do_saveToPhoneLib, do_publish_facebook;
var is_uploading = false;
var $statePublish;
var $scopePublish;

appCtrls.controller('PublishCtrl', function($scope,$state) {
  
  $scopePublish = $scope;
  $statePublish = $state;
  $scope.isReadySave = false;

  ionic.Platform.ready(function(){
    
    console.log("-- Publish -- ")    
    initPublishInterface(); 
    status('');
    resetPublish();
    canvasToDataURL();
    $('#page_publish .btn_back').show();
    
  });

  $scope.publish = function()
  {
    publish();
  };

})


function resetPublish()
{
  console.log("resetPublish");

  // reset publish settings    
  do_saveToPhoneLib = (localUsersSettings["save_mobile"]=="on") ? true : false; 
    
  $('#publish_list').hide();  
  //$('#btn_pub').hide();
  $scopePublish.isReadySave = false;

  $('#img_publish_holder').empty();
}

function updatePublishSettings(e)
{
  var sel = $(e.target);  
  var setting_name = sel.attr('name');
  var setting_value = sel.val();
  var setting_bool = (setting_value == "on") ? true : false;
  
  if(setting_name == "publish_private")
  {
    do_uploadToServer = (setting_bool) ? false : true;
    
    if(do_uploadToServer)
    {
      $('#select-publish_facebook').slider('enable')
      $('#btn_publish_facebook').removeClass('disabled')
    }
    else
    {
      $('#select-publish_facebook').slider('disable')
      $('#select-publish_facebook').val("off").slider('refresh');
      $('#btn_publish_facebook').addClass('disabled')
      do_publish_facebook = false;
    }
  }
  else if(setting_name == "publish_facebook")
  {
    do_publish_facebook = setting_bool;
  }
  
  console.log("do_saveToPhoneLib",do_saveToPhoneLib)
  console.log("do_uploadToServer",do_uploadToServer); 
  console.log("do_publish_facebook",do_publish_facebook); 
  
}

//============================================================
// INIT INTERFACE
//============================================================

function initPublishInterface()
{


  console.log("initPublishInterface");
  
  $(document).bind('isSavedToPhoneLib', function(event) { 
  
    status("➜ Image saved!");
    setTimeout(function() {$statePublish.go('create');}, 1000);
    
  });   

  
  $('#btn_publish_instagram').on(events.start,openInstagram);  
} 




//============================================================
// CANVAS TO B64
//============================================================

function canvasToDataURL()
{
  console.log("canvasToDataURL"); 
  
  //remove help first
  container_help.alpha=0;
  stage.update();
  
  imageData = canvasCreate.toDataURL().replace(/data:image\/png;base64,/,'');
  //$('#saveImg').attr('src',"data:image/png;base64," + imageData);
  
  //initCanvasMini(imageData);
  
  $('<img id="saveImg" src="data:image/png;base64,'+imageData+'" style="opacity:0"/>')  
  .load(function()
  {
    $(this).css({'width':canvasW,'height':canvasW,'opacity':1,'-webkit-transition':'opacity .5s ease-in-out'});
    //$('#btn_pub').fadeIn(500);
    $scopePublish.isReadySave = true;
    
    status('');

    //initOptions();
    
  })
  .error(function()
  {
    console.log("error loading image"); 
    $(this).hide();
  })
  .prependTo('#img_publish_holder')
}

//============================================================
// CHECK PUBLISH SETTINGS AND GO FOR IT
//============================================================

function publish()
{  
  $('#btn_pub').hide();
  $scopePublish.isReadySave = false;
  $('#publish_list').hide();  
  
  saveToPhoneLib();
    
  console.log("do_saveToPhoneLib : " + do_saveToPhoneLib);  
}

//============================================================
// 1. SAVE TO PHONE LIB
//============================================================

function saveToPhoneLib()
{
  console.log("saveToPhoneLib...");
  status("➜ Saving image to camera roll...");
      
  canvas2ImagePlugin.saveImageDataToLibrary(
    function(data){
      
      imageURI = data;
      
      console.log("saveToPhoneLib OK : "+ data);
      $(document).trigger('isSavedToPhoneLib');
      
      //console.log(isUploadToServer.state());
      //navigator.notification.alert(msg);      
    }, 
    function(err){
      console.log("saveToPhoneLib Error : " + err);
    }, 
    'canvasCreate'
  );
}


//============================================================
// OPTIONS
//============================================================

function initOptions()
{
  Instagram.isInstalled(function (err, installed) {
    if (installed) {

      $('#publish_list').show();
      console.log("Instagram is installed");
      $('#btn_publish_instagram').show()      

    } else {
      console.log("Instagram is not installed");
      $('#btn_publish_instagram').hide()
    }
  });
}
//============================================================
// INSTAGRAM
//============================================================

function openInstagram()
{
  Instagram.share('canvasCreate', function (err) {
    if (err) {
      console.log("not shared");
    } else {
      console.log("shared");
    }
  });
}

//============================================================
//  DISPLAY 
//============================================================

function status(msg)
{
  $("#status").html(msg);
}

